diff --git a/src/backend/optimizer/path/allpaths.c b/src/backend/optimizer/path/allpaths.c
index 633b5c1..d65eb1b 100644
--- a/src/backend/optimizer/path/allpaths.c
+++ b/src/backend/optimizer/path/allpaths.c
@@ -2934,6 +2934,13 @@ compute_parallel_worker(RelOptInfo *rel, BlockNumber heap_pages,
 
 			parallel_workers = heap_parallel_workers;
 		}
+		else
+			/*
+			 * In case of inheritance child table with zero heap pages
+			 * we assign at least 1 parallel worker so as to generate
+			 * partial path.
+			 */
+			parallel_workers = 1;
 
 		if (index_pages > 0)
 		{