From 25e4a3517ef81c50de6b092ad00a9f384358ade1 Mon Sep 17 00:00:00 2001
From: Peter Eisentraut <peter@eisentraut.org>
Date: Mon, 10 Apr 2017 22:54:13 -0400
Subject: [PATCH 1/2] Make h2 orange in the documentation

With the XSLT stylesheets, most chunk headings are not h2 instead of
formerly h1, so make h2 orange as well to match the previous style.
---
 media/css/docs.css | 1 +
 1 file changed, 1 insertion(+)

diff --git a/media/css/docs.css b/media/css/docs.css
index 10d6f48..bf57615 100644
--- a/media/css/docs.css
+++ b/media/css/docs.css
@@ -167,6 +167,7 @@ h1 {
 
 h2 {
   font-size: 1.2em !important;
+  color: #EC5800;
 }
 
 h3 {
-- 
2.12.2