From 43cbeb8093f824916a714f00e019d5b4270fab5e Mon Sep 17 00:00:00 2001
From: Peter Eisentraut <peter@eisentraut.org>
Date: Mon, 10 Apr 2017 22:54:13 -0400
Subject: [PATCH v2 1/3] Make h2 orange in the documentation

With the XSLT stylesheets, most chunk headings are not h2 instead of
formerly h1, so make h2 orange as well to match the previous style.
---
 media/css/docs.css | 9 +++++++++
 1 file changed, 9 insertions(+)

diff --git a/media/css/docs.css b/media/css/docs.css
index 10d6f48..dc8a068 100644
--- a/media/css/docs.css
+++ b/media/css/docs.css
@@ -185,6 +185,15 @@ h4 a:hover {
   text-decoration: none;
 }
 
+/*
+ * Change color of h2 chunk titles in XSL build.  (In DSSSL build,
+ * these will be h1, which is already handled elsewhere.)
+ */
+.titlepage h2.title,
+.refnamediv h2 {
+  color: #EC5800;
+}
+
 /* Text Styles */
 
 div.sect2,
-- 
2.12.2