From e49ff550e67d8d2234f4a8e34e56f47f0c63fd34 Mon Sep 17 00:00:00 2001
From: Peter Eisentraut <peter@eisentraut.org>
Date: Tue, 11 Apr 2017 10:11:55 -0400
Subject: [PATCH v2 3/3] Adjust selectors for table style

Older DocBook XSL stylesheets don't have a class on the table element,
but all versions have a surrounding div element with class "table", so
use that instead.
---
 media/css/docs.css | 18 +++++++++---------
 1 file changed, 9 insertions(+), 9 deletions(-)

diff --git a/media/css/docs.css b/media/css/docs.css
index 6fb05b9..30c1277 100644
--- a/media/css/docs.css
+++ b/media/css/docs.css
@@ -255,7 +255,7 @@ pre.literallayout,
 .warning,
 .note,
 .tip,
-table.table,
+.table table,
 pre.LITERALLAYOUT,
 .SCREEN,
 .SYNOPSIS,
@@ -390,8 +390,8 @@ table {
   margin-left: 2ex;
 }
 
-table.table td,
-table.table th,
+.table table td,
+.table table th,
 table.CALSTABLE td,
 table.CALSTABLE th,
 table.CAUTION td,
@@ -401,7 +401,7 @@ table.WARNING th {
   border-style: solid;
 }
 
-table.table,
+.table table,
 table.CALSTABLE,
 table.CAUTION,
 table.WARNING {
@@ -409,7 +409,7 @@ table.WARNING {
   border-collapse: collapse;
 }
 
-table.table,
+.table table,
 table.CALSTABLE
 {
   margin: 2ex 0 2ex 2ex;
@@ -417,19 +417,19 @@ table.CALSTABLE
   border: 2px solid #A7C6DF;
 }
 
-table.table tr:hover td,
+.table table tr:hover td,
 table.CALSTABLE tr:hover td
 {
   background-color: #EFEFEF;
 }
 
-table.table td,
+.table table td,
 table.CALSTABLE td {
   background-color: #FFF;
 }
 
-table.table td,
-table.table th,
+.table table td,
+.table table th,
 table.CALSTABLE td,
 table.CALSTABLE th {
   border: 1px solid #A7C6DF;
-- 
2.12.2