From 71082f1a8b8e684a107a433114770080c645a091 Mon Sep 17 00:00:00 2001
From: umairshahid <umair.shahid@2ndquadrant.com>
Date: Tue, 2 May 2017 13:04:23 +0500
Subject: [PATCH] Adding 9.5/9.6 edition of PostgreSQL Administration Cookbook

---
 .../packt_postgresql_admin_cookbook_9596edition.png    | Bin 0 -> 109933 bytes
 templates/pages/docs/books.html                        |  16 ++++++++++++++++
 2 files changed, 16 insertions(+)
 create mode 100644 media/img/docs/books/packt_postgresql_admin_cookbook_9596edition.png

diff --git a/media/img/docs/books/packt_postgresql_admin_cookbook_9596edition.png b/media/img/docs/books/packt_postgresql_admin_cookbook_9596edition.png
new file mode 100644
index 0000000000000000000000000000000000000000..e4a0f0049af807402e038a78d4af0dc6b1805fb3
GIT binary patch
diff --git a/templates/pages/docs/books.html b/templates/pages/docs/books.html
index 70ebebb..a39c466 100644
--- a/templates/pages/docs/books.html
+++ b/templates/pages/docs/books.html
@@ -12,6 +12,22 @@
 
 <tr>
         <td class="colFirst">
+            <a href="https://www.packtpub.com/big-data-and-business-intelligence/postgresql-administration-cookbook-9596-edition"><img
+                        src="/media/img/docs/books/packt_postgresql_admin_cookbook_9596edition.png"
+                        alt="PostgreSQL Administration Cookbook - 9.5/9.6 Edition" /></a>
+        </td>
+        <td class="colLast">
+                 <b>Title</b>: PostgreSQL Administration Cookbook - 9.5/9.6 Edition<br />
+                 <b>Author</b>: Simon Riggs, Gianni Ciolli, Gabriele Bartolini<br />
+                 <b>Language</b>: English<br />
+                 <b>Current version at publication</b>: 9.6<br />
+                 <b>Format</b>: Paperback, eBook<br />
+                 <b>Published</b>: April 2017<br />
+        </td>
+</tr>
+
+<tr>
+        <td class="colFirst">
             <a href="https://www.packtpub.com/big-data-and-business-intelligence/postgresql-high-performance-cookbook"><img
                         src="/media/img/docs/books/packt_postgresql_high_performance_cookbook.png"
                         alt="PostgreSQL High Performance Cookbook" /></a>
-- 
2.11.0 (Apple Git-81)