From 5a7e5428c4bceb8bdac33e33fd2db2eb4f351dc1 Mon Sep 17 00:00:00 2001
From: Peter Eisentraut <peter_e@gmx.net>
Date: Tue, 2 May 2017 12:10:22 -0400
Subject: [PATCH] doc: Refine release date formatting

Change the formatting of the release date from note to formalpara,
because the former is too flamboyant.
---
 doc/src/sgml/release-10.sgml  |  9 ++++-----
 doc/src/sgml/release-9.6.sgml | 24 ++++++++++++------------
 2 files changed, 16 insertions(+), 17 deletions(-)

diff --git a/doc/src/sgml/release-10.sgml b/doc/src/sgml/release-10.sgml
index 241064e58e..c26203e4ee 100644
--- a/doc/src/sgml/release-10.sgml
+++ b/doc/src/sgml/release-10.sgml
@@ -4,11 +4,10 @@
  <sect1 id="release-10">
   <title>Release 10</title>
 
-  <note>
-   <title>Release Date</title>
-   <simpara>2017-09-XX</simpara>
-   <simpara>CURRENT AS OF 2017-04-22</simpara>
-  </note>
+  <formalpara>
+   <title>Release date:</title>
+   <para>2017-09-XX (CURRENT AS OF 2017-04-22)</para>
+  </formalpara>
 
   <sect2>
    <title>Overview</title>
diff --git a/doc/src/sgml/release-9.6.sgml b/doc/src/sgml/release-9.6.sgml
index dc7b479387..dc35791ad7 100644
--- a/doc/src/sgml/release-9.6.sgml
+++ b/doc/src/sgml/release-9.6.sgml
@@ -4,10 +4,10 @@
  <sect1 id="release-9-6-2">
   <title>Release 9.6.2</title>
 
-  <note>
-  <title>Release Date</title>
-  <simpara>2017-02-09</simpara>
-  </note>
+  <formalpara>
+  <title>Release date:</title>
+  <para>2017-02-09</para>
+  </formalpara>
 
   <para>
    This release contains a variety of fixes from 9.6.1.
@@ -1421,10 +1421,10 @@ <title>Changes</title>
  <sect1 id="release-9-6-1">
   <title>Release 9.6.1</title>
 
-  <note>
-  <title>Release Date</title>
-  <simpara>2016-10-27</simpara>
-  </note>
+  <formalpara>
+  <title>Release date:</title>
+  <para>2016-10-27</para>
+  </formalpara>
 
   <para>
    This release contains a variety of fixes from 9.6.0.
@@ -2016,10 +2016,10 @@ <title>Changes</title>
  <sect1 id="release-9-6">
   <title>Release 9.6</title>
 
-  <note>
-   <title>Release Date</title>
-   <simpara>2016-09-29</simpara>
-  </note>
+  <formalpara>
+   <title>Release date:</title>
+   <para>2016-09-29</para>
+  </formalpara>
 
   <sect2>
    <title>Overview</title>
-- 
2.12.2